SUBROUTINE CHNBYDRIFT(JBNS,JBSS,JBN,JBS,JMAX)

    IMPLICIT DOUBLE PRECISION(A-H,N,O-Z)

    INTEGER IDAY,JBNS,JBSS,JBN,JBS,JMAX,J,JJS

    REAL(8) N(4,401),TI(3,401),F(20)
    REAL(8) U(2,401),BG(401),BM(401),GR(2,401),R(2,401),SL(401)
    REAL(8) OPLS(401),VOPLS(401),HE(401),UE(2,401),HEPRD(401),OP(401)

    REAL(8) NSA(4,401),TISA(3,401),USA(2,401),UESA(2,401)
    REAL(8) GL(401),GLS(401),RADDEG

    REAL(8) NO1(JBNS),NH1(JBNS),NHE1(JBNS),TO1(JBNS),TH1(JBNS)
    REAL(8) TE1(JBNS),UO1(JBNS),UH1(JBNS),UHE1(JBNS)
    REAL(8) THETA1S(JBNS),THETA1(JBN)
    REAL(8) NO2(JMAX-JBSS+1),NH2(JMAX-JBSS+1),NHE2(JMAX-JBSS+1)
    REAL(8) TO2(JMAX-JBSS+1),TH2(JMAX-JBSS+1),TE2(JMAX-JBSS+1)
    REAL(8) UO2(JMAX-JBSS+1),UH2(JMAX-JBSS+1),UHE2(JMAX-JBSS+1)
    REAL(8) THETA2S(JMAX-JBSS+1),THETA2(JBS:JMAX)

    REAL(4) AP(7),DEC,ETRAN,BLON,F107,F107A,SEC

    COMMON/FJS/N,TI,F
    COMMON/VN/U,BG,BM,GR,R,SL
    COMMON/A/OPLS,VOPLS,HE,UE,HEPRD,OP
      
    COMMON/SAVENTV/NSA,TISA,USA,UESA,GLS
    COMMON/MSIS/AP,DEC,ETRAN,BLON,F107,F107A,IDAY,SEC,GL
  
    RADDEG=180.0/acos(-1.d0)
    THETA1S(1:JBNS)=90.0-GLS(1:JBNS)*RADDEG
    THETA1(1:JBN)=90.0-GL(1:JBN)*RADDEG

    NO1=N(1,1:JBNS)
    NH1=N(2,1:JBNS)
    NHE1=N(4,1:JBNS)
    TH1=TI(2,1:JBNS)
    TO1=TI(1,1:JBNS)
    TE1=TI(3,1:JBNS)
    UO1=U(1,1:JBNS)
    UH1=U(2,1:JBNS)
    UHE1=UE(1,1:JBNS)

    DO J=1,JBN
      CALL LGRG(THETA1S,NO1,JBNS,THETA1(J),N(1,J))
      CALL LGRG(THETA1S,NH1,JBNS,THETA1(J),N(2,J))
      CALL LGRG(THETA1S,NHE1,JBNS,THETA1(J),N(4,J))
      CALL LGRG(THETA1S,TH1,JBNS,THETA1(J),TI(2,J))
      CALL LGRG(THETA1S,TO1,JBNS,THETA1(J),TI(1,J))
      CALL LGRG(THETA1S,TE1,JBNS,THETA1(J),TI(3,J))
      CALL LGRG(THETA1S,UO1,JBNS,THETA1(J),U(1,J))
      CALL LGRG(THETA1S,UH1,JBNS,THETA1(J),U(2,J))
      CALL LGRG(THETA1S,UHE1,JBNS,THETA1(J),UE(1,J))
    ENDDO

    JJS=JMAX-JBSS+1
    THETA2S(1:JJS)=90.0-GLS(JBSS:JMAX)*RADDEG
    THETA2(JBS:JMAX)=90.0-GL(JBS:JMAX)*RADDEG

    NO2=N(1,JBSS:JMAX)
    NH2=N(2,JBSS:JMAX)
    NHE2=N(4,JBSS:JMAX)
    TH2=TI(2,JBSS:JMAX)
    TO2=TI(1,JBSS:JMAX)
    TE2=TI(3,JBSS:JMAX)
    UO2=U(1,JBSS:JMAX)
    UH2=U(2,JBSS:JMAX)
    UHE2=UE(1,JBSS:JMAX)

    DO J=JBS,JMAX   
      CALL LGRG(THETA2S,NO2,JJS,THETA2(J),N(1,J))
      CALL LGRG(THETA2S,NH2,JJS,THETA2(J),N(2,J))
      CALL LGRG(THETA2S,NHE2,JJS,THETA2(J),N(4,J))
      CALL LGRG(THETA2S,TH2,JJS,THETA2(J),TI(2,J))
      CALL LGRG(THETA2S,TO2,JJS,THETA2(J),TI(1,J))
      CALL LGRG(THETA2S,TE2,JJS,THETA2(J),TI(3,J))
      CALL LGRG(THETA2S,UO2,JJS,THETA2(J),U(1,J))
      CALL LGRG(THETA2S,UH2,JJS,THETA2(J),U(2,J))
      CALL LGRG(THETA2S,UHE2,JJS,THETA2(J),UE(1,J))
    ENDDO

END SUBROUTINE
